Subject: Re: [PATCH v7 net-next 2/2] net: airoha: Introduce ethernet support for EN7581 SoC

From: Jakub Kicinski <[email-masked]>
Date: Fri, 12 Jul 2024 08:00:02 -0700

On Fri, 12 Jul 2024 16:43:58 +0200 Lorenzo Bianconi wrote:
> > On Fri, 12 Jul 2024 15:47:38 +0200 Lorenzo Bianconi wrote:  
> > > The Airoha eth SoC architecture is similar to mtk_eth_soc one (e.g MT7988a).
> > > The FrameEngine (FE) module has multiple GDM ports that are connected to
> > > different blocks. Current airoha_eth driver supports just GDM1 that is connected
> > > to a MT7530 DSA switch (I have not posted a tiny patch for mt7530 driver yet).
> > > In the future we will support even GDM{2,3,4} that will connect to differ
> > > phy modues (e.g. 2.5Gbps phy).  
> > 
> > What I'm confused by is the mentioned of DSA. You put the port in the
> > descriptor, and there can only be one switch on the other side, right?  
> 
> do you mean fport in msg1 (airoha_dev_xmit())?
> 
> 	fport = port->id == 4 ? FE_PSE_PORT_GDM4 : port->id;
> 	msg1 = FIELD_PREP(QDMA_ETH_TXMSG_FPORT_MASK, fport) |
> 	       ...
> 
> fport refers to the GDM port and not to the dsa user port. Am I missing
> something?

Ooh, I see, reading what you explained previously now makes sense.
So only 1 of the ports goes to the DSA switch, and the other ones
are connected to SoC pins? A diagram would be worth a 1000 words ;)

> > be in a setup like this :( It will have no way to figure out the real
> > egress rate given that each netdev only sees a (non-)random sample
> > of traffic sharing the queue :(  
> 
> do you prefer to remove BQL support?

No strong preference, I worry it will do more harm than good in
this case. It's not what it's designed for basically. But without
testing it's all speculation, so up to you, users can always disable
using sysfs.